
#include "lcd.h"
#include "banner.h"
#include "compiler.h"
#include "GenericTypeDefs.h"

#define WAIT_TIME  2

/*****************************************************************************
* Function: BannerProcessEvents
*
* Preconditions: None
*
* Overview: This function can be used to print a string on the lcd display
*
* Input: Two strings that need to be printed on the lcd (upper, lower)
*
* Output: None.
*
******************************************************************************/
void BannerProcessEvents(char * ubanner1, char* ubanner2 )
{
BYTE line = 1;
BYTE uBannerLen = LCD_DISPLAY_LEN;
BYTE wait = WAIT_TIME;
char * uBanner = ubanner1;
while(1)
{
	LCDProcessEvents();
	if(!mLCDIsBusy())
	{
		mLCDHome();
		break;
	}
}
while((uBannerLen!=0) | (line==1))
{
	LCDProcessEvents();
	while(wait)
		{
			wait--;
			LCDProcessEvents();
			
		}
	if(uBannerLen)
	{
		if(!mLCDIsBusy())				//put char
		{
			mLCDPutChar(*uBanner);
			uBanner++;
			uBannerLen--;
		}
	}
	if((uBannerLen == 0))	
	{		
		if(line == 1)
		{						//move to second line
			if(!mLCDIsBusy())
			{
				mLCDPutCmd(0xC0);
				uBannerLen = LCD_DISPLAY_LEN;
				uBanner = ubanner2;
				line = 2;
			}
		}	
	}
	
} //end of while loop
}//end of the function
